unit Keyboard; { copyright (c) 1994,1995 Dan Melton -- All rights reserved }

interface

uses
  DOS;

const
{
  kF9      = $01;
  kF5      = $03;
  kF3      = $04;
  kF1      = $05;
  kF2      = $06;
  kF12     = $07;
  kF10     = $09;
  kF8      = $0A;
  kF6      = $0B;
  kF4      = $0C;
  kTAB     = $0D;
  kCQUOTE  = $0E;
  kLALT    = $11;
  kLSHIFT  = $12;
  kLCTRL   = $14;
  kQ       = $15;
  kN1      = $16;
  kZ       = $1A;
  kS       = $1B;
  kA       = $1C;
  kW       = $1D;
  kN2      = $1E;
  kC       = $21;
  kX       = $22;
  kD       = $23;
  kE       = $24;
  kN4      = $25;
  kN3      = $26;
  kSPACE   = $29;
  kV       = $2A;
  kF       = $2B;
  kT       = $2C;
  kR       = $2D;
  kN5      = $2E;
  kN       = $31;
  kB       = $32;
  kH       = $33;
  kG       = $34;
  kY       = $35;
  kN6      = $36;
  kM       = $3A;
  kJ       = $3B;
  kU       = $3C;
  kN7      = $3D;
  kN8      = $3E;
  kCOMMA   = $41;
  kK       = $42;
  kI       = $43;
  kO       = $44;
  kN0      = $45;
  kN9      = $46;
  kPERIOD  = $49;
  kSLASH   = $4A;
  kL       = $4B;
  kSCOLON  = $4C;
  kP       = $4D;
  kMINUS   = $4E;
  kOQUOTE  = $52;
  kLBRACE  = $54;
  kEQUAL   = $55;
  kCAPLOCK = $58;
  kRSHIFT  = $59;
  kENTER   = $5A;
  kRBRACE  = $5B;
  kBSLASH  = $5D;
  kBACKSPC = $66;
  kP1      = $69;
  kP4      = $6B;
  kP7      = $6C;
  kINS     = $70;
  kDEL     = $71;
  kP2      = $72;
  kP5      = $73;
  kP6      = $74;
  kP8      = $75;
  kESC     = $76;
  kNUMLOCK = $77;
  kF11     = $78;
  kPPLUS   = $79;
  kP3      = $7A;
  kPMINUS  = $7B;
  kSTAR    = $7C;
  kP9      = $7D;
  kSCRLOCK = $7E;
  kF7      = $83;
  kSYSRQ   = $84;
  kRALT    = $91;
  kRCTRL   = $94;
  kPSLASH  = $CA;
  kEENTER  = $DA;
  kEND     = $E9;
  kLF      = $EB;
  kHOME    = $EC;
  kINS2    = $F0;
  kDEL2    = $F1;
  kDN      = $F2;
  kRT      = $F4;
  kUP      = $F5;
  kPGDN    = $FA;
  kPRTSC   = $FC;
  kPGUP    = $FD;
}

  kESC     = $01;         kN1      = $02;         kN2      = $03;
  kN3      = $04;         kN4      = $05;         kN5      = $06;
  kN6      = $07;         kN7      = $08;         kN8      = $09;
  kN9      = $0A;         kN0      = $0B;         kMINUS   = $0C;
  kEQUAL   = $0D;         kBACKSPC = $0E;         kTAB     = $0F;
  kQ       = $10;         kW       = $11;         kE       = $12;
  kR       = $13;         kT       = $14;         kY       = $15;
  kU       = $16;         kI       = $17;         kO       = $18;
  kP       = $19;         kLBRACE  = $1A;         kRBRACE  = $1B;
  kENTER   = $1C;         kLCTRL   = $1D;         kA       = $1E;
  kS       = $1F;         kD       = $20;         kF       = $21;
  kG       = $22;         kH       = $23;         kJ       = $24;
  kK       = $25;         kL       = $26;         kSCOLON  = $27;
  kOQUOTE  = $28;         kCQUOTE  = $29;         kLSHIFT  = $2A;
  kBSLASH  = $2B;         kZ       = $2C;         kX       = $2D;
  kC       = $2E;         kV       = $2F;         kB       = $30;
  kN       = $31;         kM       = $32;         kCOMMA   = $33;
  kPERIOD  = $34;         kSLASH   = $35;         kRSHIFT  = $36;
  kSTAR    = $37;         kLALT    = $38;         kSPACE   = $39;
  kCAPLOCK = $3A;         kF1      = $3B;         kF2      = $3C;
  kF3      = $3D;         kF4      = $3E;         kF5      = $3F;
  kF6      = $40;         kF7      = $41;         kF8      = $42;
  kF9      = $43;         kF10     = $44;         kNUMLOCK = $45;
  kSCRLOCK = $46;         kP7      = $47;         kP8      = $48;
  kP9      = $49;         kPMINUS  = $4A;         kP4      = $4B;
  kP5      = $4C;         kP6      = $4D;         kPPLUS   = $4E;
  kP1      = $4F;         kP2      = $50;         kP3      = $51;
  kINS     = $52;         kDEL     = $53;         kF11     = $57;
  kF12     = $58;         kEENTER  = $9C;         kRCTRL   = $9D;
  kPRTSC   = $AA;         kPSLASH  = $B5;         kRALT    = $B8;
  kHOME    = $C7;         kUP      = $C8;         kPGUP    = $C9;
  kLF      = $CB;         kRT      = $CD;         kEND     = $CF;
  kDN      = $D0;         kPGDN    = $D1;         kINS2    = $D2;
  kDEL2    = $D3;         kLWIN    = $DB;         kRWIN    = $DC;
  kMENU    = $DD;

  KBflagCallInt9 : Boolean = FALSE;
  KBflagNoBuffer : Boolean = TRUE;

  ASCIITranslation: Array[0..$FF] Of Char =
   (' ',' ','1','2','3','4','5','6','7','8','9','0','-','=',' ',' ',
    'q','w','e','r','t','y','u','i','o','p','[',']',' ',' ','a','s',
    'd','f','g','h','j','k','l',';','''','`',' ','\','z','x','c','v',
    'b','n','m',',','.','/','*',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','-',' ',' ',' ','+',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ');

  ASCIITranslationShift: Array[0..$FF] Of Char =
   (' ',' ','!','@','#','$','%','^','&','*','(',')','_','+',' ',' ',
    'Q','W','E','R','T','Y','U','I','O','P','{','}',' ',' ','A','S',
    'D','F','G','H','J','K','L',':','"','~',' ','|','Z','X','C','V',
    'B','N','M','<','>','?','*',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','-',' ',' ',' ','+',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
    ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ');

  ProduceChar: Array[0..$FF] Of Byte =
   (0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
    1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
    1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,
    1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

var
  Key : array [$00..$FF] of byte;

procedure InitKeyboard;
procedure ExitKeyboard;

implementation

Uses Time;

const
  Ok2Exit : boolean = false;
  OldProc : pointer = nil;
  OldInt9 : pointer = nil;

  Ext : word = 0;
{  Release: word = 0;}

Var
  T1,T2     : LongInt;
  LoopCount : LongInt;
(*
Procedure Keyboard_Write(TheByte: Byte);
{ -------------------------------------------------------------- }
{ Send byte B to the keyboard controller (port 60h).  Assumes no }
{ BIOS interrupt 9 handler active.                               }
{ -------------------------------------------------------------- }
Var
  B    : Byte;
  Loop : LongInt;

Begin

  { Poll the keyboard until the keyboard is ready or until 5ms have }
  { elapsed                                                         }

  Loop := LoopCount;
  Repeat
    B  := Port[$64];
    Dec(Loop);
  Until ((B And 2) = 0) Or (Loop <= 0);
  If (B And 2) = 0 Then Port[$60] := TheByte
  Else WriteLn('Keyboard_Write error 1  B = ',B);
  Loop := LoopCount;
  Repeat
    B  := Port[$64];
    Dec(Loop);
  Until ((B And 2) = 0) Or (Loop <= 0);
  If Loop <= 0 Then WriteLn('Keyboard_Write error 2  B = ',B);
End; { Keyboard_Write }


Procedure Keyboard_Cmd(Cmd: Byte);
{ -------------------------------------------------------------- }
{ Send a command to the keyboard controller (port 64h).          }
{ -------------------------------------------------------------- }
Var
  B    : Byte;
  Loop : LongInt;

Begin

  { Poll the keyboard until the keyboard is ready or until 5ms have }
  { elapsed                                                         }

  Loop := LoopCount;
  Repeat
    B  := Port[$64];
    Dec(Loop);
  Until ((B And 2) = 0) Or (Loop <= 0);
  If (B And 2) = 0 Then
  Begin
    Port[$64] := Cmd;

    { Poll the keyboard until the keyboard is ready or until 5ms have }
    { elapsed                                                         }

    Loop := LoopCount;
    Repeat
      B  := Port[$64];
      Dec(Loop);
    Until ((B And 2) = 0) Or (Loop <= 0);
    If Loop <= 0 Then WriteLn('Keyboard_Cmd error 2  B = ',B);
  End
  Else WriteLn('Keyboard_Cmd error 1  B = ',B);
End; { Keyboard_Cmd }


Procedure SetScanCodeSet(CodeSet: Byte);
{ -------------------------------------------------------------- }
{ Sets the keyboard scan code set                                }
{ -------------------------------------------------------------- }
Begin
{  Keyboard_Write($F0);
  Keyboard_Write(CodeSet);}
  Keyboard_Write($F5);
  Keyboard_Write($F4);
End; { SetScanCodeSet }


procedure NewInt09; interrupt; assembler;
  asm
    in    al,060h

    MOV   BX,0B800h
    MOV   ES,BX
    MOV   BL,BYTE PTR Release
    MOV   BH,BYTE PTR Key[kESC]
    MOV   BYTE PTR ES:[0],BL
    MOV   BYTE PTR ES:[2],AL
    MOV   BYTE PTR ES:[4],BH

    CMP   AL,0F0h
    JNE   @@NotRelease
{    CMP   WORD PTR Ext,(offset Key+00080h)
    JE    @@NotRelease}
    MOV   [Release],1
    JMP   @@quit
@@NotRelease:

    cmp   al,0E0h
    jne   @@normalkey
    mov   [Ext],(offset Key+00080h)
    jmp   @@quit
@@normalkey:
    CMP   AL,0E0h
    JA    @@Quit  { Ignore "special" results }






    mov   bx,ax
    mov   si,[Ext]

    AND   BX,00FFh

{    and   bx,0007Fh}

{    shr   al,7}
    add   si,bx

    MOV   AX,[Release]

    xor   al,001h
    mov   ds:[si],al
    mov   [Ext],offset Key
    mov   ax,040h
    mov   es,ax
    MOV   [Release],0
@@quit:
    test  [KBflagCallInt9],not false
    jnz   @@callorig
    mov   al,020h
    out   020h,al
    jmp   @@done
@@callorig:
    pushf
    call  [OldInt9]
    test  [KBflagNoBuffer],not false
    jz @@done
@@killkbuf:
    mov   word ptr es:[0001Ah],01Eh
    mov   word ptr es:[0001Ch],01Eh
@@done:
  end;
*)

procedure NewInt09; interrupt; assembler;
  asm
    in    al,060h

    cmp   al,0E0h
    jne   @@normalkey
    mov   [Ext],(offset Key+00080h)
    jmp   @@quit
@@normalkey:
    mov   bx,ax
    mov   si,[Ext]
    and   bx,0007Fh
    shr   al,7
    add   si,bx
    xor   al,001h
    mov   ds:[si],al
    mov   [Ext],offset Key
    mov   ax,040h
    mov   es,ax
@@quit:
    test  [KBflagCallInt9],not false
    jnz   @@callorig
    mov   al,020h
    out   020h,al
    jmp   @@done
@@callorig:
    pushf
    call  [OldInt9]
    test  [KBflagNoBuffer],not false
    jz @@done
@@killkbuf:
    mov   word ptr es:[0001Ah],01Eh
    mov   word ptr es:[0001Ch],01Eh
@@done:
  end;


procedure UndoKeyboard; far;
  begin
{
    WriteLn('exit 1');

    Keyboard_Cmd($60);

    WriteLn('exit 2');

    Keyboard_Write($45);

    WriteLn('exit 3');

    Keyboard_Write($F4);

    WriteLn('exit 4');
}
    if not OK2Exit then exit;
    SetIntVec($09,OldInt9);
    Ok2Exit:=false;
    ExitProc:=OldProc;
  end;

procedure InitKeyboard;
  begin
    if Ok2Exit then exit;
    OldProc  := ExitProc;
    ExitProc := @UndoKeyboard;

{
    WriteLn('init 1');

    Keyboard_Cmd($60);

    WriteLn('init 2');

    Keyboard_Write($25);

    WriteLn('init 3');

    Keyboard_Write($F4);

    WriteLn('init 4');
}
    Ext      := ofs(Key[0]);
{    Release  := 0;}
    GetIntVec($09,OldInt9);
    SetIntVec($09,@NewInt09);
    Ok2Exit:=true;
  end;

procedure ExitKeyboard;
  begin
    Undokeyboard;
  end;

Begin
  FillChar(Key,SizeOf(Key),#0);

  { Find out how long it takes to wait 5 ms }

  Repeat
    LoopCount := 0;
    T1        := Clock;
    Repeat
      Inc(LoopCount);
      T2 := Clock;
    Until (T2 < T1) Or (T2 >= T1 + 100);
  Until T2 >= T1 + 100;
  LoopCount := LoopCount Div 20;
end.
